import { PeerConnection, Service, ServiceConfiguration } from '@cross-lab-project/soa-client';
import Queue from 'queue';
import { TypedEmitter } from 'tiny-typed-emitter';
import { ConnectionInterface, ConnectionInterfaceConfiguration, ConstructableConnectionInterface } from './connectionInterface.js';
interface ConnectionInterfaceConfigurationUpstream extends ConnectionInterfaceConfiguration {
    interfaceType: string;
    interfaceId: string;
    busId: string;
}
type ServiceType = 'goldi/electrical';
declare const ServiceType: ServiceType;
export interface ElectricalServiceConfiguration extends ServiceConfiguration {
    serviceType: ServiceType;
    interfaces: ConnectionInterfaceConfigurationUpstream[];
}
export interface NewInterfaceEvent {
    connectionInterface: ConnectionInterface;
}
interface ElectricalConnectionServiceEvents {
    newInterface: (event: NewInterfaceEvent) => void;
}
type FullStateType<SignalType extends string> = Record<SignalType, any>;
export declare class ElectricalConnectionService<ServiceId extends string = string, SignalType extends string = string> extends TypedEmitter<ElectricalConnectionServiceEvents> implements Service<ServiceType, ServiceId, FullStateType<SignalType>> {
    serviceDirection: import("@cross-lab-project/soa-client").ServiceDirection;
    serviceType: "goldi/electrical";
    serviceId: ServiceId;
    interfaceConstructors: Map<string, ConstructableConnectionInterface>;
    interfaces: Map<string, ConnectionInterface>;
    interfacesByBusId: Map<string, string[]>;
    signals: string[];
    queue: Queue;
    constructor(serviceId: ServiceId, signals: SignalType[]);
    getMeta(): {
        serviceType: "goldi/electrical";
        serviceId: ServiceId;
        serviceDirection: import("@cross-lab-project/soa-client").ServiceDirection;
        interfaces: {
            interfaceType: string;
            availableSignals: {
                [role: string]: string[];
            };
        }[];
    };
    get_state(): FullStateType<SignalType>;
    addInterface(electricalInterfaceConstructor: ConstructableConnectionInterface): void;
    retransmit(): void;
    setupConnection(connection: PeerConnection, serviceConfig: ServiceConfiguration): void;
    initializeConnection(): void;
    handleData(data: string | Blob | ArrayBuffer | ArrayBufferView): void;
}
export {};
//# sourceMappingURL=service.d.ts.map